+++
title = "分片"
weight = 3
+++

## 分片键

用于将数据库（表）水平拆分的数据库字段。
例：将订单表中的订单主键的尾数取模分片，则订单主键为分片字段。
SQL 中如果无分片字段，将执行全路由，性能较差。
除了对单分片字段的支持，Apache ShardingSphere 也支持根据多个字段进行分片。

## 分片算法

用于将数据分片的算法，支持 `=`、`>=`、`<=`、`>`、`<`、`BETWEEN` 和 `IN` 进行分片。
分片算法可由开发者自行实现，也可使用 Apache ShardingSphere 内置的分片算法语法糖，灵活度非常高。

### 自动化分片算法

分片算法语法糖，用于便捷的托管所有数据节点，使用者无需关注真实表的物理分布。
包括取模、哈希、范围、时间等常用分片算法的实现。

### 自定义分片算法

提供接口让应用开发者自行实现与业务实现紧密相关的分片算法，并允许使用者自行管理真实表的物理分布。
自定义分片算法又分为：

- 标准分片算法

用于处理使用单一键作为分片键的 `=`、`IN`、`BETWEEN AND`、`>`、`<`、`>=`、`<=` 进行分片的场景。

- 复合分片算法

用于处理使用多键作为分片键进行分片的场景，包含多个分片键的逻辑较复杂，需要应用开发者自行处理其中的复杂度。

- Hint 分片算法

用于处理使用 `Hint` 行分片的场景。

## 分片策略

包含分片键和分片算法，由于分片算法的独立性，将其独立抽离。
真正可用于分片操作的是分片键 + 分片算法，也就是分片策略。

## 强制分片路由

对于分片字段并非由 SQL 而是其他外置条件决定的场景，可使用 SQL Hint 注入分片值。
例：按照员工登录主键分库，而数据库中并无此字段。
SQL Hint 支持通过 Java API 和 SQL 注释（待实现）两种方式使用。
详情请参见[强制分片路由](/cn/features/sharding/concept/hint/)。
